hdu 5222

首先对于所有的无向边,我们使用并查集将两边的点并起来 若一条边未合并之前,两端的点已经处于同一个集合了,那么说明必定存在可行的环(因为这两个点处于同一个并查集集合中,那么它们之间至少存在一条路径) 如果上一步没有判断出环,那么仅靠无向边是找不到环的 考虑到,处于同一个并查集集合中的点之间必定存在一条路径互达,因此将一个集合的点合并之后,原问题等价于在新生成的有向图中是否有环 我们知道,有向无环图必定存在拓扑序,因此只需使用拓扑排序判定即可 时间复杂度O(N+M1+M2)O(N + M1 + M2)O(N+M1+M2)

笨人搓码  hdu的栈溢出真是快让我炸了。。

  1 /*Author :usedrose  */
  2 /*Created Time :2015/7/31 18:35:37*/
  3 /*File Name :2.cpp*/
  4 #pragma comment(linker, "/STACK:102400000,102400000")
  5 #include <cstdio>
  6 #include <iostream>
  7 #include <algorithm>
  8 #include <sstream>
  9 #include <cstdlib>
 10 #include <cstring>
 11 #include <climits>
 12 #include <vector>
 13 #include <string>
 14 #include <ctime>
 15 #include <cmath>
 16 #include <deque>
 17 #include <queue>
 18 #include <stack>
 19 #include <set>
 20 #include <map>
 21 #define INF 0x3f3f3f3f
 22 #define eps 1e-8
 23 #define pi acos(-1.0)
 24 #define MAXN 1000000
 25 #define OK cout << "ok" << endl;
 26 #define o(a) cout << #a << " = " << a << endl
 27 #define o1(a,b) cout << #a << " = " << a << "  " << #b << " = " << b << endl
 28 using namespace std;
 29 typedef long long LL;
 30
 31 int fa[MAXN];
 32 int n, m1, m2;
 33 vector<int> G[MAXN];
 34 int vis[MAXN], ind[MAXN];
 35
 36 int findset(int x)
 37 {
 38     return fa[x] = fa[x] == x ? x:findset(fa[x]);
 39 }
 40
 41 bool merg(int a, int b)
 42 {
 43     int x = findset(a);
 44     int y = findset(b);
 45     if (x == y) return false;
 46     fa[x] = y;
 47     return true;
 48 }
 49
 50 void init()
 51 {
 52     for (int i = 1;i <= n; ++ i) {
 53         fa[i] = i;
 54         ind[i] = 0;
 55         G[i].clear();
 56     }
 57 }
 58
 59
 60 bool toposort()
 61 {
 62     queue<int> Q;
 63     for (int i = 1;i <= n; ++ i) {
 64         if (ind[i] == 0 && fa[i] == i)
 65             Q.push(i);
 66     }
 67     while (!Q.empty()) {
 68         int t = Q.front();
 69         Q.pop();
 70         for (int i = 0;i < G[t].size(); ++ i) {
 71             int v = G[t][i];
 72             if (--ind[v] == 0)
 73                 Q.push(v);
 74         }
 75     }
 76     for (int i = 1;i <= n; ++ i)
 77         if (ind[i])
 78             return false;
 79     return true;
 80 }
 81
 82 int main()
 83 {
 84     //freopen("data.in","r",stdin);
 85     //freopen("data.out","w",stdout);
 86     int T;
 87     scanf("%d", &T);
 88     while (T--) {
 89         scanf("%d%d%d", &n, &m1, &m2);
 90         init();
 91         bool ans = true;
 92         int x, y;
 93         for (int i = 1;i <= m1; ++ i) {
 94             scanf("%d%d", &x, &y);
 95             ans &= merg(x, y);
 96         }
 97
 98         for (int i = 1;i <= m2; ++ i) {
 99             scanf("%d%d", &x, &y);
100             x = findset(x);
101             y = findset(y);
102             G[x].push_back(y);
103             ind[y]++;
104         }
105         if (ans == 0) {
106             puts("YES");
107             continue;
108         }
109
110         ans = toposort();
111         puts(ans? "NO" : "YES");
112     }
113     return 0;
114 }
时间: 2024-10-10 15:47:55

hdu 5222的相关文章

HDU 5222 ——Exploration——————【并查集+拓扑排序判有向环】

Exploration Time Limit: 30000/15000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 194    Accepted Submission(s): 63 Problem Description Miceren likes exploration and he found a huge labyrinth underground! This la

【HDU】5222 Exploration(并查集+拓扑排序)

对于无向边使用并查集合并成一个集合,对于有向边使用判断是否存在环 唯一无语的地方就是看输入是百万级的,加个输入挂跑9s,不加挂跑了5s #include<cstdio> #include<cstring> #include<vector> #include<algorithm> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") const

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

HDU 5917 Instability ramsey定理

http://acm.hdu.edu.cn/showproblem.php?pid=5917 即世界上任意6个人中,总有3个人相互认识,或互相皆不认识. 所以子集 >= 6的一定是合法的. 然后总的子集数目是2^n,减去不合法的,暴力枚举即可. 选了1个肯定不合法,2个也是,3个的话C(n, 3)枚举判断,C(n, 4), C(n, 5) #include <bits/stdc++.h> #define IOS ios::sync_with_stdio(false) using name

hdu 6166 Senior Pan

地址:http://acm.split.hdu.edu.cn/showproblem.php?pid=6166 题目: Senior Pan Time Limit: 12000/6000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 245    Accepted Submission(s): 71 Problem Description Senior Pan fails i